/*
 * $Id: echo.S,v 1.1.1.1 2007/09/18 14:31:52 ydong Exp $
 * share lib: print a char on the display, it's interruptable
 * Key of certification: interrupt + concurrency + function call
 */
.text                                   # Code segment
.code16                                 # Real mode
.globl	printchar			# Globle, so others can call it

/* void printchar(short c) */
printchar:
        pushw   %bp                     # save temp regs
        movw    %sp, %bp
        pushw   %ax
        pushw   %bx
        movw    4(%bp), %ax             # character to write
        movb    $0x0e, %ah              # function number
        movb    $0x00, %bh              # active page number
        movb    $0x02, %bl              # foreground color
        int     $0x10
        popw    %bx                     # recover temp regs
        popw    %ax
        movw    %bp, %sp
        popw    %bp
        retw
