/*
 * $Id: kernel.S,v 1.6 2007/10/05 19:39:28 ydong Exp $
 * ranger call: interrupt clear and set, cli/sti for OS
 * See: Certified  Concurrent Code with Interrupts AIM2's timer handler
 * Key for verfification: interrupt + function call, AIM2
 */
	.set	CURR_CABIN, 0x22d2


#include "ccb.h"
.text                                   # Code section
.code16                                 # Real mode
.globl  rgc_cli
.globl  rgc_sti
.globl  rgc_get_curr_cabin_ID

rgc_cli:                                # ranger call cli
        cli
        pushw   %ds                     # ra and DS in OS/thread's stack

        pushw   %bx                     # ** DS switch: cabin -> ranger
        movw    $CDATA_SEGMENT, %bx
        movw    %bx, %ds

        movw    $CURR_CABIN, %bx
	movw	(%bx), %bx
        movw    $DISAB, CCB_INTFLG(%bx)
        popw    %bx                     # recover bx
        popw    %ds
        sti
        retw

rgc_sti:                                # ranger call cli
        cli
        pushw   %ds                     # ra and DS in OS/thread's stack

        pushw   %bx                     # ** DS switch: cabin -> ranger
        movw    $CDATA_SEGMENT, %bx
        movw    %bx, %ds

        movw    $CURR_CABIN, %bx
	movw	(%bx), %bx
        movw    $ENABL, CCB_INTFLG(%bx)
        popw    %bx                     # recover bx
        popw    %ds
        sti
        retw

rgc_get_curr_cabin_ID:                  # ranger call get current cabin ID
        cli
        pushw   %ds                     # ra and DS in OS/thread's stack

        pushw   %bx                     # ** DS switch: cabin -> ranger
        movw    $CDATA_SEGMENT, %bx
        movw    %bx, %ds

        movw    $CURR_CABIN, %bx
        movw    (%bx), %bx
        movw    CCB_ID(%bx),%ax		#return value = CCB_ID
        popw    %bx                     # recover bx
        popw    %ds
        sti
        retw
